package ru.ifmo.vizi.dmkm;

import java.util.StringTokenizer;
import java.io.*;

/**
 * Record for saving and loading the net.
 */
public class NetRecord {
    public int n, m;
    public int g[][];
    public int step;

    /**
     * Creates the record with specified number of vertices in net and adjacency matrix.
     * @param n
     * @param g
     */
    public NetRecord(int n, int g[][]) {
        this.n = n;
        this.g = new int[n][n];
        m = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
            	if (g[i][j] > 0) {
            		m++;
            	}
                this.g[i][j] = g[i][j];
            }
        }
    }


    private int toint(String s) {
    	return Integer.parseInt(s);
    }

    public NetRecord(String s, boolean b) {
    	int i = 0;
    	int j = 0;
    	int c = 0;
        StringTokenizer st = new StringTokenizer(s);
        try {
			n = toint(st.nextToken());
            g = new int[n][n];
			m = toint(st.nextToken());
			for (int k = 0; k < m; k++) {
				i = toint(st.nextToken());
				j = toint(st.nextToken());
				c = toint(st.nextToken());
				g[i][j] = c;
			}
			step = toint(st.nextToken());
		} catch (Exception e) {
			System.out.println("Incorrect format");
			n = 0;
		}
    }

    /**
     * Creates the record from string.
     * @param s
     */
    public NetRecord(String s) {
        StringTokenizer st = new StringTokenizer(s);
        try {
            n = Integer.parseInt(st.nextToken());
            g = new int[n][n];
            int i, j, c;
            while (st.hasMoreTokens()) {
                i = Integer.parseInt(st.nextToken());
                j = Integer.parseInt(st.nextToken());
                c = Integer.parseInt(st.nextToken());
                g[i][j] = c;
            }
        } catch (Exception e) {
            System.out.println("Exception while parsing net!");
            this.n = 2;
            this.g = new int[2][2];
            g[0][1] = 1;
        }

    }

    public String writeNet() {
		String s = n + " " + m + "\n";
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (g[i][j] > 0) {
					s += i + " " + j + " " + g[i][j] + "\n";
				}					 
			}				 
		}
		s += step;
		return s;
    }

}
