package ru.ifmo.vizi.dmkm.ui;

import ru.ifmo.vizi.base.ui.HintedButton;
import ru.ifmo.vizi.base.ui.SaveLoadDialog;
import ru.ifmo.vizi.base.Configuration;
import ru.ifmo.vizi.dmkm.DMKMVisualizer;

import java.awt.*;

/**
 * Save/load button.
 *
 * @author Yuri Bedny
 */
public class SaveLoadButton extends HintedButton {
    /**
     * Parent applet.
     */
    protected DMKMVisualizer parent;

    /**
     * Configuration manager for this button.
     */
    protected Configuration config;

    /**
     * Default constructor.
     *
     * @param parent parent applet
     * @param config configuration manager
     * @param name configuration style
     */
    public SaveLoadButton(DMKMVisualizer parent, Configuration config,
                          String name) {
        super(config, name);

        this.parent = parent;
        this.config = config;
    }

    public void click() {
        Component forefather = this;
        while (forefather.getParent() != null) {
            forefather = forefather.getParent();
        }
        Rectangle b = forefather.getBounds();
        if (!(forefather instanceof Frame)) {
            forefather = new Frame();
        }
        SaveLoadDialog saveDialog = new SaveLoadDialog(config, (Frame)forefather) {
            protected boolean load(String txt) { return true;/*parent.loadNet(txt);*/ }
            protected boolean isForbidden(char c) {
                return false;
            }
//            protected String getContent() { return parent.saveNet(); }
        };
        Dimension s = saveDialog.getSize();
        saveDialog.setLocation(
            b.x + (b.width - s.width) / 2,
            b.y + (b.height - s.height) / 2
        );
        saveDialog.setVisible(true);
    }
}
